﻿;+2do:flip font h v
;+draw with mousemove
;28-06-21 colors for chars done
;29-06-21 fixes with chr operations, save map, etc
Global charbw=1; characters b/w
Global col0=0
Global col1=RGB(255,255,255)

Global v$="8x8 font v0.2.1"
Global *m=AllocateMemory(2048+8)
Global curc=0
Global dragf=-1
Global Dim cm.a(100,100)
Global ww.l=1
Global hh.l=1
Global zf.l=2 ;zoom factor
Global spa.l  ;selected pattern
Enumeration
  #file_open
  #file_save
  
  #file_save96
  #file_save128
  #file_save256
  #file_savea
  
  #file_quit
  
  #char_clear
  #char_delete
  #char_invert
  #char_insert
  #char_clearall
  #char_fliph
  #char_flipv
  
  #drag_swap
  #drag_copy
  
  #char_zx
  #char_zx80
  #char_atari
  #char_vga866
  #char_vga
  #char_a2
  #char_c64
  
  #char_mapzx
  #char_mapat
  #char_mappc
  #charmap_clear
  #charmap_bw
  #charmap_save
  
  #save_pos_b
  #save_pos_c
  
  #zoomx1
  #zoomx2
  
  #char_s_r
  #char_s_l
  #char_s_d
  #char_s_u
  
  #mnu_up
  #mnu_dn
  #mnu_left
  #mnu_right
EndEnumeration

#canvas=256
#chr=257 ;check range
#cbf=258 ; from
#cbt=259 ; to
#charmap=260

Procedure redraw()
  
  t$=v$+":"+Str(curc)
  If curc>=32
    t$=t$+",'"+Chr(curc)+"'"
  EndIf
  SetWindowTitle(0,t$)
  
  zm=1
  If GetMenuItemState(0,#zoomx2):zm=2:EndIf
  
  For i=0 To 255
    StartDrawing( ImageOutput(i) )
    Box (0,0,16,16,0)
    If i=curc
      cl=RGB(0,0,255)
    Else
      cl=col0
    EndIf
    
    For y=0 To 7
      a.l=PeekL(*m+i*8+y)
      b.l=128
      For x=0 To 7
        If a&b
          Box(x*zm,y*zm,2,2,col1);RGB(255,255,255) )
        Else
          Box(x*zm,y*zm,2,2,cl )
        EndIf
        b=b>>1
      Next x
    Next y
    StopDrawing()
    SetGadgetState(i,ImageID(i) )
  Next i
  
  ;grid for char
  StartDrawing( CanvasOutput(#canvas) )
  Box (0,0,128,128,col0)
  
   
  For y=0 To 7
    a.l=PeekL(*m+curc*8+y)
    b.l=128
    For x=0 To 7
      If a&b
        Box (x*16,y*16,16,16,col0)
        Box (x*16,y*16,15,15,col1)
      Else
        Box (x*16,y*16,16,16,col1)
        Box (x*16,y*16,15,15,col0)
      EndIf
      b=b>>1
 ;          LineXY(x*16,y*16,x*16+15,y*16,col1)
 ;          LineXY(x*16,y*16,x*16,y*16+15,col1)

    Next x
  Next y
  StopDrawing()
EndProcedure

Procedure readchar(fn.s)
  If ReadFile(0,fn)
    fs=FileSize(fn)
    
    If fs+curc*8<=2048;;;;fs >0?????
      ReadData(0,*m+curc*8,fs);не читает, если выбраны последние клетки
                              ;     Else
                              ;       MessageRequester("Attention!","choose char from #0 to #255",#PB_MessageRequester_Ok)
    EndIf
    CloseFile(0)
  Else
    MessageRequester("Error!","error reading file:"+Chr($0a)+fn,#PB_MessageRequester_Ok)
  EndIf
EndProcedure

Procedure del_char()
  If curc<255
    CopyMemory(*m+curc*8+8,*m+curc*8,2048-(curc*8+8))
  Else
    MessageRequester("Oops!","delete last char!",#PB_MessageRequester_Ok)
  EndIf
EndProcedure

Procedure ins_char()
  For i=2039 To curc*8 Step -1
    PokeA( *m+i+8,PeekA(*m+i) )
  Next i
  For i=0 To 7
    PokeA(*m+i+curc*8,0)
  Next i
EndProcedure

Procedure createmnu()
  
  If CreateMenu(0, WindowID(0))    ; menu creation starts....
    MenuTitle("File")
    MenuItem(#file_open, "Open"   +Chr(9)+"Ctrl+O")
    
    OpenSubMenu("Save")
    MenuItem(#file_save96, "ZX 96 chars(768bytes)")
    MenuItem(#file_save128, "Atari 128 chars(1024bytes)")
    MenuItem(#file_save256, "IBM 256 chars(2048bytes)")
    MenuBar()
    MenuItem(#save_pos_b, "save from begin")
    MenuItem(#save_pos_c, "save from cursor")
    CloseSubMenu()
    
    MenuBar()
    OpenSubMenu("Charset")
    MenuItem(#char_zx, "ZX Spectrum")
    MenuItem(#char_zx80, "ZX80")
    MenuItem(#char_atari, "Atari")
    MenuItem(#char_a2, "Apple 2")
    MenuItem(#char_vga, "MS-DOS VGA")
    MenuItem(#char_vga866, "MS-DOS VGA cp866(rus)")
    MenuItem(#char_c64, "C64")
    CloseSubMenu()
    
    MenuBar()
    MenuItem(#file_quit, "Quit"  +Chr(9)+"Ctrl+Q")
    MenuTitle("Character")
    OpenSubMenu("Map")
    MenuItem(#char_mapzx, "ZX(32x24)")
    MenuItem(#char_mapat, "Atari/C64(40x24)")
    MenuItem(#char_mappc, "PC(80x25)")
    MenuBar()
    MenuItem(#charmap_clear, "fill map with current")
    MenuItem(#charmap_bw, "Characters Black/White")
    MenuItem(#charmap_save, "Save map...")
    SetMenuItemState(0,#charmap_bw,charbw)
    CloseSubMenu()
    MenuBar()
    MenuItem(#char_clear, "Clear")
    MenuItem(#char_delete, "Delete"   +Chr(9)+"Del")
    MenuItem(#char_insert, "Insert"   +Chr(9)+"Ins")
    MenuItem(#char_invert, "Invert")
    MenuItem(#char_fliph, "Mirror vertical")
    MenuItem(#char_flipv, "Mirror horisontal")
    
    MenuItem(#char_clearall, "Clear all")
    OpenSubMenu("Scroll")
    MenuItem(#char_s_l, "Scroll left"+Chr(9)+"Ctrl+LeftArrow")
    MenuItem(#char_s_r, "Scroll right"+Chr(9)+"Ctrl+RightArrow")
    MenuItem(#char_s_u, "Scroll up"+Chr(9)+"Ctrl+UpArrow")
    MenuItem(#char_s_d, "Scroll down"+Chr(9)+"ctrl+DownArrow")
    CloseSubMenu()
    
    MenuTitle("Drag Mode")
    MenuItem(#drag_copy, "Copy")
    MenuItem(#drag_swap, "Swap")
    
    MenuTitle("Zoom")
    MenuItem(#zoomx1, "x1")
    MenuItem(#zoomx2, "x2")
    
  EndIf
  
  SetMenuItemState(0, #zoomx2, 1)
  SetMenuItemState(0, #save_pos_b, 1)
  
  SetMenuItemState(0, #drag_copy, 1)
  AddKeyboardShortcut(0, #PB_Shortcut_Control | #PB_Shortcut_O, #file_open)
  AddKeyboardShortcut(0, #PB_Shortcut_Control | #PB_Shortcut_Q, #file_quit)
  
  AddKeyboardShortcut(0, #PB_Shortcut_Left, #mnu_left)
  AddKeyboardShortcut(0, #PB_Shortcut_Right, #mnu_right)
  
  AddKeyboardShortcut(0, #PB_Shortcut_Up, #mnu_up)
  AddKeyboardShortcut(0, #PB_Shortcut_Down, #mnu_dn)
  
  AddKeyboardShortcut(0, #PB_Shortcut_Control | #PB_Shortcut_Left, #char_s_l)
  AddKeyboardShortcut(0, #PB_Shortcut_Control | #PB_Shortcut_Right, #char_s_r)
  
  AddKeyboardShortcut(0, #PB_Shortcut_Control | #PB_Shortcut_Up, #char_s_u)
  AddKeyboardShortcut(0, #PB_Shortcut_Control | #PB_Shortcut_Down, #char_s_d)
  
EndProcedure

Procedure invchar(cc.a)
  For i=0 To 7
    PokeA( *m+i+cc*8,255-PeekA(*m+i+cc*8) )
  Next i
EndProcedure

Procedure charsd(cc.a)
  a.a=PeekA(*m+cc*8+7)
  For i=7 To 1 Step -1
    PokeA(*m+cc*8+i,PeekA(*m+cc*8+i-1))
  Next i
  PokeA(*m+cc*8,a)
EndProcedure

Procedure charsr(cc.a)
  For i=0 To 7
    a.a=PeekA(*m+cc*8+i)
    a=((a&1)*128)|(a>>1)
    PokeA(*m+cc*8+i,a)
  Next i
EndProcedure

Procedure charsl(cc.a)
  For i=0 To 7
    a.a=PeekA(*m+cc*8+i)
    a=((a&128)/128)|(a<<1)
    PokeA(*m+cc*8+i,a)
  Next i
EndProcedure

Procedure charsu(cc.a)
  a.a=PeekA(*m+cc*8+0)
  For i=0 To 6
    PokeA(*m+cc*8+i,PeekA(*m+cc*8+i+1))
  Next i
  PokeA(*m+cc*8+7,a)
EndProcedure

Procedure flipvchar(cc.a)
  For i=0 To 3
    a.a=PeekA(*m+cc*8+i)
    b.a=PeekA(*m+cc*8+7-i)
    PokeA(*m+cc*8+7-i,a)
    PokeA(*m+cc*8+i,b)
  Next i
  
EndProcedure

Procedure fliphchar(cc.a)
  
  For i=0 To 7
    a.a=PeekA(*m+cc*8+i)
    c.a=0
    For j=0 To 7
      c=((c<<1)|(a&1))
      a=a>>1
    Next j
    PokeA(*m+cc*8+i,c)
  Next i
  
EndProcedure

Procedure clearchar(cc.a)
  For i=0 To 7
    PokeA(*m+i+cc*8,0)
  Next i
  
EndProcedure

Procedure groupop(*f)
  If GetGadgetState(#chr)
    b1.l=GetGadgetState(#cbf)
    b2.l=GetGadgetState(#cbt)
    
    If b1>=b2
      MessageRequester("Group","Cannot perform with range "+Str(b1)+"-"+Str(b2),#PB_MessageRequester_Ok)
    Else
      For i= b1 To b2
        CallFunctionFast (*f,i )
      Next i
    EndIf
    
  Else
    CallFunctionFast (*f,curc )
  EndIf
  
EndProcedure

Procedure drawcharmap()
  If IsWindow(1)
    StartDrawing( CanvasOutput(#charmap) )
    For x=0 To ww-1
      For y=0 To hh-1
        For yy=0 To 7
          ch.a=PeekA(*m+cm(x,y)*8+yy)
          bw.l=128
          For xx=0 To 7
            If ch&bw
              co.l=col1;$FFFFFF
            Else
              co=col0;0
            EndIf
            Box( (x*8+xx)*zf,(y*8+yy)*zf,zf,zf,co)
            bw>>1
          Next
        Next
      Next y
    Next x
    
    dd=8*zf
    x = Int(GetGadgetAttribute(#charmap, #PB_Canvas_MouseX)/dd)*dd
    y = Int(GetGadgetAttribute(#charmap, #PB_Canvas_MouseY)/dd)*dd
    DrawingMode(#PB_2DDrawing_Outlined )
    Box(x,y,8*zf,8*zf,255)
    StopDrawing()
  EndIf
EndProcedure

Procedure openchar(w,h)
  If Not IsWindow(1)
    ;Dim cm(w,h)
    ww=w
    hh=h
    If OpenWindow(1,0,0,w*8*zf,h*8*zf,"Character Map",#PB_Window_SystemMenu|#PB_Window_ScreenCentered|#PB_Window_MinimizeGadget)
      CanvasGadget(#charmap,0,0,w*8*zf,h*8*zf)
      ;redraw()
      drawcharmap()
    EndIf
  EndIf
EndProcedure

Procedure checkcol()
  If GetMenuItemState(0,#charmap_bw)
    col0=0
    col1=RGB(255,255,255)
  EndIf 
EndProcedure

If OpenWindow(0,0,0,400,18*16+8,v$,#PB_Window_SystemMenu|#PB_Window_ScreenCentered|#PB_Window_MinimizeGadget)
  CanvasGadget(#canvas, 17*16, 0, 128, 128):GadgetToolTip(#canvas, "Char Editor");;+Chr(10)+"click on map")
  EnableWindowDrop(0,#PB_Drop_Files,#PB_Drag_Copy)
  CheckBoxGadget(#chr,17*16,128,80,20,"range"):GadgetToolTip(#chr, "Apply operation to range")
  ComboBoxGadget(#cbf,17*16,148,60,20):GadgetToolTip(#cbf, "1st character")
  ComboBoxGadget(#cbt,17*16+60,148,60,20):GadgetToolTip(#cbt, "last character")
  
  
  For i=0 To 255
    t$=Str(i)
    If i>=32
      t$=t$+"("+Chr(i)+")"
    EndIf
    AddGadgetItem(#cbf,-1,t$)
    AddGadgetItem(#cbt,-1,t$)
  Next i
EndIf

createmnu()

;menu Char-erase,delete,scroll,invert
For i=0 To 255
  CreateImage(i,16,16)
  ImageGadget(i, 17*(i&15),17*(i>>4),16,16,ImageID(i))
  t$=Str(i)
  If i<32
    t$=t$+",' '"
  Else
    t$=t$+",'"+Chr(i)+"'"
  EndIf
  ;Debug t$
  GadgetToolTip(i,t$)
  EnableGadgetDrop(i,    #PB_Drop_Image,   #PB_Drag_Copy)
Next i

; ReadFile(0,"STOP.FONT")
; ReadData(0,*m,768)
; CloseFile(0)
; 
redraw()

isq=0
Repeat
  ev=WaitWindowEvent()
  eg=EventGadget()
  et=EventType()
  
  If ev = #PB_Event_Gadget And eg = #charmap
    If et=#PB_EventType_MouseMove 
      drawcharmap()
    ElseIf et=#PB_EventType_LeftClick
      dd=8*zf
      x = Int(GetGadgetAttribute(#charmap, #PB_Canvas_MouseX)/dd)
      y = Int(GetGadgetAttribute(#charmap, #PB_Canvas_MouseY)/dd)
      cm(x,y)=curc
      drawcharmap()
    EndIf
    
  EndIf
  
  If GetAsyncKeyState_(#VK_ESCAPE)=-32767
    isq=1
  EndIf
  
  If GetAsyncKeyState_(#VK_DELETE)=-32767
    del_char()
    redraw()
  EndIf
  
  If GetAsyncKeyState_(#VK_INSERT)=-32767
    ins_char()
    redraw()
  EndIf
  
  
  If ev=#PB_Event_Menu
    em=EventMenu()
    Select em
      Case #charmap_bw
        charbw=1-charbw
        SetMenuItemState(0,#charmap_bw,charbw)
      Case #charmap_clear
        For y=0 To 100
          For x=0 To 100
            cm(x,y)=curc
          Next
        Next
        drawcharmap()
        
      Case #char_mapzx:openchar(32,24)
      Case #char_mapat:openchar(40,24)
      Case #char_mappc:openchar(80,25)
      Case #mnu_up
        If curc>>4
          curc-16
        EndIf
        redraw()
      Case #mnu_dn
        If (curc>>4)<>15
          curc+16
        EndIf
        redraw()
      Case #mnu_left
        If curc&15
          curc-1
        EndIf
        redraw()
        
      Case #mnu_right
        If curc&15<>15
          curc+1
        EndIf
        redraw()
        
      Case #char_s_u ;scroll up
        groupop(@charsu())
        redraw()
        drawcharmap()
        
      Case #char_s_d; scroll down
        groupop(@charsd())
        redraw()
        drawcharmap()
        
      Case #char_s_l;scroll left
        groupop(@charsl())
        redraw()
        drawcharmap()
        
      Case #char_s_r; scroll right
        groupop(@charsr())
        redraw()
        drawcharmap()
        
      Case #save_pos_b
        SetMenuItemState(0, #save_pos_b, 1)
        SetMenuItemState(0, #save_pos_c, 0)
        ;drawcharmap()
        
      Case #save_pos_c
        SetMenuItemState(0, #save_pos_c, 1)
        SetMenuItemState(0, #save_pos_b, 0)
        ;drawcharmap()
        
      Case #zoomx1
        SetMenuItemState(0, #zoomx1, 1)
        SetMenuItemState(0, #zoomx2, 0)
        zf=1
        redraw()
        ;drawcharmap()
        
      Case #zoomx2
        SetMenuItemState(0, #zoomx1, 0)
        SetMenuItemState(0, #zoomx2, 1)
        zf=2
        redraw()
        ;drawcharmap()
        
      Case #file_quit
        isq=1
        
      Case #file_save96 To #file_save256
        StandardFile$ = GetCurrentDirectory(); set initial file+path to display
        Pattern$ = "FNT (*.fnt)|*.fnt|Binary (*.bin)|*.bin|All files (*.*)|*.*"
        ;Pattern = 0 
        File$ = OpenFileRequester("Please choose file to load", StandardFile$, Pattern$, 0);Pattern)
        If File$
          ;check .fnt
          If (LCase(GetExtensionPart(File$)))<>"fnt"
            File$=File$+".fnt"
          EndIf
          
          ;save file
          If CreateFile(0,File$)
            
            tow=2048
            If em=#file_save96:tow=768:EndIf
            If em=#file_save128:tow=1024:EndIf
            savefr=GetMenuItemState(0,#save_pos_c)*curc*8
            
            If savefr+tow>2048
              tow=(255-curc)*8
            EndIf
            
            WriteData(0,*m+savefr,tow)
            CloseFile(0)
          Else
            MessageRequester("Error", "Error writing file.try again", 0)
          EndIf
          
          ;         Else
          ;           MessageRequester("Information", "The requester was canceled.", 0)
        EndIf
        
      Case #charmap_save
        Pattern$ = "CharMap(*.map)|*.map"
        File$ = SaveFileRequester("Please choose file to save", "", Pattern$, 0)
        If File$
          e$=Mid(File$,Len(File$)-3)
          If LCase(e$)<>".map"
            File$+".map"
          EndIf
          If CreateFile(0,File$)
            For y=0 To hh-1
              For x=0 To ww-1
                WriteAsciiCharacter(0,cm(x,y))
              Next x
            Next y
            CloseFile(0)
          Else
            MessageRequester("File error!","Can't write"+#CRLF$+File$)
          EndIf
        EndIf
        
        
      Case #file_open
        StandardFile$ = GetCurrentDirectory(); set initial file+path to display
        Pattern$ = "FNT(*.fnt)|*.fnt|Binary (*.bin)|*.bin|CharMap(*.map)|*.map|All files (*.*)|*.*"
        File$ = OpenFileRequester("Please choose file to load", StandardFile$, Pattern$, spa)
        If File$
          spa=SelectedFilePattern()
          Select spa
            Case 0,1,3
              readchar(File$)
              redraw()
            Case 2
              If IsWindow(1)
                If OpenFile(0,File$)
                  For y=0 To hh-1
                    For x=0 To ww-1
                      If Not Eof(0)
                        cm(x,y)=ReadAsciiCharacter(0)
                      EndIf
                    Next x
                  Next y
                  CloseFile(0)
                  drawcharmap()
                Else
                  MessageRequester("File error!","Can't read"+#CRLF$+File$)
                EndIf
              EndIf
          EndSelect
          ;Else
          ;MessageRequester("Information", "The requester was canceled.", 0) 
        EndIf
        ;---characters        
      Case #char_c64
        MoveMemory(?c64,*m,2048)
        col0=RGB(62,49,162)
        col1=RGB(124,112,218)
        checkcol()
        redraw()
        
      Case #char_zx
        MoveMemory(?zx,*m,2048)
        col1=0
        col0=RGB(127,127,127)
        checkcol()
        redraw()
        
      Case #char_zx80
        FillMemory(*m,2048,0)
        MoveMemory(?zx80,*m,512)
        For i=0 To 511
          PokeA( *m+512+i,255!PeekA(*m+i) )
        Next i
        col1=0
        col0=RGB(255,255,255)
        checkcol()
        redraw()
        
      Case #char_a2
        MoveMemory(?apple2,*m,2048)
        redraw()
        
      Case #char_atari
        FillMemory(*m,2048,0)
        MoveMemory(?atari,*m,1024)
        For i=0 To 1023
          PokeA( *m+1024+i,255!PeekA(*m+i) )
        Next i
        col0=RGB(0,81,129)
        col1=RGB(96,183,231)
        checkcol()
        redraw()
        
      Case #char_vga
        MoveMemory(?vga,*m,2048)
        checkcol()
        redraw()
        
      Case #char_vga866
        MoveMemory(?vga866,*m,2048)
        checkcol()
        redraw()
        
      Case #drag_copy
        SetMenuItemState(0, #drag_copy, 1)
        SetMenuItemState(0, #drag_swap, 0)
      Case #drag_swap
        SetMenuItemState(0, #drag_copy, 0)
        SetMenuItemState(0, #drag_swap, 1)
        
        
        ;       Case #char_s_l ;scroll left
        ;         groupop(@slchar())
        ;         redraw()
        ;         drawcharmap()
        
      Case #char_flipv
        groupop(@flipvchar())
        redraw()
        drawcharmap()
      Case #char_fliph
        groupop(@fliphchar())
        redraw()
        drawcharmap()
      Case #char_clear
        ;         For i=0 To 7
        ;           PokeA(*m+i+curc*8,0)
        ;         Next i
        groupop(@clearchar())
        redraw()
        drawcharmap()
      Case #char_delete
        del_char()
        drawcharmap()
      Case #char_clearall
        FillMemory(*m,2048,0,#PB_Byte)
        drawcharmap()
      Case #char_insert
        ins_char()
        drawcharmap()
      Case #char_invert
        groupop(@invchar())
        drawcharmap()
        redraw()
    EndSelect
    
  EndIf
  
  If ev=#PB_Event_WindowDrop
    Files$ = EventDropFiles()
    Files$ = StringField(Files$, 1, Chr(10))
    readchar(Files$)
    redraw()
    drawcharmap()
  EndIf
  
  If ev = #PB_Event_Gadget And eg = #canvas 
    x=(WindowMouseX(0)-GadgetX(#canvas))/16
    y=(WindowMouseY(0)-GadgetY(#canvas))/16
    a.a=PeekA(*m+curc*8+y)
    ;If EventType() = #PB_EventType_MouseMove And GetGadgetAttribute(#canvas, #PB_Canvas_Buttons) & #PB_Canvas_LeftButton
    If GetGadgetAttribute(#canvas, #PB_Canvas_Buttons) & #PB_Canvas_LeftButton
      PokeA(*m+curc*8+y, a|(128>>x))
    Else
      If GetGadgetAttribute(#canvas, #PB_Canvas_Buttons) & #PB_Canvas_RightButton;EventType() =#PB_EventType_RightButtonDown
        PokeA( *m+curc*8+y, a&(~(128>>x)) )
      EndIf
    EndIf
    redraw()
    drawcharmap()
  EndIf
  
  If Ev = #PB_Event_Gadget And et = #PB_EventType_DragStart
    DragImage(ImageID(eg))
    dragf=eg
  EndIf
  
  If ev = #PB_Event_GadgetDrop
    If dragf<>-1
      For i=0 To 7
        a.a=PeekA(*m+dragf*8+i)
        b.a=PeekA(*m+eg*8+i)
        ;;;;;;;;;;;;;swap or not
        If GetMenuItemState(0,#drag_swap)
          PokeA(*m+dragf*8+i,b)
        EndIf
        PokeA(*m+eg*8+i,a)
      Next i
      dragf=-1
      redraw()
    EndIf
  EndIf
  
  If et=#PB_EventType_LeftClick And ev=#PB_Event_Gadget
    Select eg
      Case 0 To 255
        curc=eg
        redraw()
    EndSelect
  EndIf
  
  Select ev
    Case #PB_Event_CloseWindow
      If EventWindow()=0
        isq=1
      Else
        CloseWindow(1)
      EndIf
  EndSelect
  
Until isq
FreeMemory(*m)

DataSection
  zx:
  IncludeBinary "fonts\zx8x8.fnt";2048
  
  atari:
  IncludeBinary "fonts\atari.fnt";1024
  
  vga:
  IncludeBinary "fonts\msdos.fnt";2048
  
  vga866:
  IncludeBinary "fonts\msdos866.fnt";2048
  zx80:
  IncludeBinary "fonts\zx80.fnt";512
  apple2:
  IncludeBinary "fonts\APPLE II+ - PIG FONT CHARACTER GENERATOR - 2716.bin";2048
  
  c64:
  IncludeBinary "fonts\c64.bin";4096
  
EndDataSection
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 185
; FirstLine = 170
; Folding = ---
; EnableXP
; UseIcon = myabc.ico
; Executable = ch8x8.exe